use simcore_rs::*;

struct MyStruct<'s>(Sim<'s>);

impl Drop for MyStruct<'_> {
    fn drop(&mut self) {
        eprintln!("Drop");
        self.0.activate(async move {
            eprintln!("Start");
        });
    }
}

fn main() {
    simulation((), |sim| {
        Process::new(sim, async move {
            sim.activate(async move {
                let _s = MyStruct(sim);
                sim.advance(2.0).await;
            });
            sim.advance(1.0).await;
        })
    });
}
